<?php
abstract class FilterDecorator implements Filter {
    private $filter;
    public function __construct(Filter $filter) {
        $this->filter = $filter;
    }

    public function execute(Request $request, Response $response) {
        $this->filter->execute($request, $response);
        $this->doExecute($request, $response);
    }

    abstract public function doExecute(Request $request, Response $response);
}
?>