<?php
require_once 'FrontController.php';
require_once 'HttpRequest.php';
require_once 'HttpResponse.php';
require_once 'FileSystemCommandResolver.php';

require_once 'Registry.php';

require_once 'filters/HttpAuthFilter.php';
require_once 'filters/UppercaseFilter.php';
require_once 'filters/WordwrapFilter.php';

require_once 'EventDispatcher.php';
require_once 'handlers/AuthLoggingHandler.php';
require_once 'handlers/IpCheckHandler.php';


$resolver = new FileSystemCommandResolver('commands', 'HelloWorld');
$controller = new FrontController($resolver);

$authFilter = new HttpAuthFilter(
                        array(
                           'schst' => 'schst123',
                           'gerd'  => 'gerd123'
                        )
                  );
$controller->addPreFilter($authFilter);

$controller->addPostFilter(new UppercaseFilter());
$controller->addPostFilter(new WordwrapFilter());

$request = new HttpRequest();
$response = new HttpResponse();

$dispatcher = EventDispatcher::getInstance();

$ipCheck = new IpCheckHandler(array('127.0.0.1'));
$dispatcher->addHandler('onLogin', $ipCheck);

$logger = new AuthLoggingHandler('auth.log');
$dispatcher->addHandler('onInvalidLogin', $logger);
$dispatcher->addHandler('onLogin', $logger);

$controller->handleRequest($request, $response);
?>