<?php
require_once 'Command.php';
require_once 'Request.php';
require_once 'Response.php';
require_once 'FilterChain.php';
require_once 'Filter.php';

class FrontController {

    private $resolver;
    private $preFilters;
    private $postFilters;

    public function __construct(CommandResolver $resolver) {
        $this->resolver = $resolver;
        $this->preFilters = new FilterChain();
        $this->postFilters = new FilterChain();
    }

    public function addPreFilter(Filter $filter) {
        $this->preFilters->addFilter($filter);
    }

    public function addPostFilter(Filter $filter) {
        $this->postFilters->addFilter($filter);
    }

    public function handleRequest(Request $request, Response $response) {
        $this->preFilters->processFilters($request, $response);
        $command = $this->resolver->getCommand($request);
        $command->execute($request, $response);
        $this->postFilters->processFilters($request, $response);

        $response->flush();
    }
}
?>