<?php
require_once 'Filter.php';

class HttpAuthFilter implements Filter {
    private $authData;

    public function __construct($authData) {
        $this->authData = $authData;
    }

    public function execute(Request $request, Response $response) {
        $authData = $request->getAuthData();
        if ($authData === null) {
            $this->sendAuthRequest($response);
        }
        $username = $authData['user'];
        $password = $authData['password'];
        if (!isset($this->authData[$username]) || $this->authData[$username] !== $password) {
            $this->sendAuthRequest($response);
        }
    }

    private function sendAuthRequest(Response $response) {
        $response->setStatus('401 Unauthorized');
        $response->addHeader('WWW-Authenticate', 'Basic realm="PHP Design Patterns"');
        $response->flush();
        exit();
    }
}
?>