<?php
require_once 'Event.php';
require_once 'EventHandler.php';

class EventDispatcher {
    private $handlers = array();
    static private $instance;

    static public function getInstance() {
        if (self::$instance === null) {
            self::$instance = new EventDispatcher();
        }
        return self::$instance;
    }

    protected function __construct() {
    }

    private function __clone() {
    }

    public function addHandler($eventName, EventHandler $handler) {
        if (!isset($this->handlers[$eventName])) {
            $this->handlers[$eventName] = array();
        }
        $this->handlers[$eventName][] = $handler;
    }

    public function triggerEvent($event, $context = null, $info = null) {
        if (!$event instanceof Event) {
            $event = new Event($event, $context, $info);
        }
        $eventName = $event->getName();
        if (!isset($this->handlers[$eventName])) {
            return $event;
        }
        foreach ($this->handlers[$eventName] as $handler) {
            $handler->handle($event);
            if ($event->isCancelled()) {
                break;
            }
        }
        return $event;
    }
}
?>