<?php
require_once 'CommandResolver.php';

class FileSystemCommandResolver implements CommandResolver {
    private $path;
    private $defaultCommand;

    public function __construct($path, $defaultCommand) {
        $this->path = $path;
        $this->defaultCommand = $defaultCommand;
    }

    public function getCommand(Request $request) {
        if ($request->issetParameter('cmd')) {
            $cmdName = $request->getParameter('cmd');
            $command = $this->loadCommand($cmdName);
            if ($command instanceof Command) {
                return $command;
            }
        }
        $command = $this->loadCommand($this->defaultCommand);
        return $command;
    }

    protected function loadCommand($cmdName) {
        $class = "{$cmdName}Command";
        $file  = "commands/{$cmdName}Command.php";
        if (!file_exists($file)) {
            return false;
        }
        include_once $file;
        if (!class_exists($class)) {
            return false;
        }
        $command = new $class();
        return $command;
    }
}
?>