<?php
require_once 'FrontController.php';
require_once 'HttpRequest.php';
require_once 'HttpResponse.php';
require_once 'FileSystemCommandResolver.php';

require_once 'Registry.php';

require_once 'filters/HttpAuthFilter.php';
require_once 'filters/UppercaseFilter.php';
require_once 'filters/WordwrapFilter.php';

require_once 'EventDispatcher.php';

$resolver = new FileSystemCommandResolver('commands', 'HelloWorld');
$controller = new FrontController($resolver);

$authFilter = new HttpAuthFilter(
                        array(
                           'schst' => 'schst123',
                           'gerd'  => 'gerd123'
                        )
                  );
$controller->addPreFilter($authFilter);

$request = new HttpRequest();
$response = new HttpResponse();

$controller->handleRequest($request, $response);
?>